/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.bausystem.features.simulator.gui;

import de.steamwar.bausystem.features.simulator.SimulatorCursor;
import de.steamwar.bausystem.features.simulator.data.Simulator;
import de.steamwar.bausystem.features.simulator.gui.base.SimulatorBaseGui;
import de.steamwar.data.CMDs;
import de.steamwar.inventory.SWItem;
import org.bukkit.Material;
import org.bukkit.entity.Player;

import java.util.Collections;

public class SimulatorCursorSwitcherGui extends SimulatorBaseGui {

    private SimulatorBaseGui back;

    public SimulatorCursorSwitcherGui(Player player, Simulator simulator, SimulatorBaseGui back) {
        super(player, simulator, 9);
        this.back = back;
    }

    @Override
    public String title() {
        return "Simulator Cursor";
    }

    @Override
    public void populate() {
        inventory.setItem(0, new SWItem(Material.ARROW, "§eBack", clickType -> {
            back.open();
        }).setCustomModelData(CMDs.BACK));

        int slot = 2;
        SimulatorCursor.CursorType currentType = SimulatorCursor.getCursorType(player);
        for (SimulatorCursor.CursorType type : SimulatorCursor.CursorType.values()) {
            boolean selected = type == currentType;
            SWItem swItem = new SWItem(selected ? type.material : type.nonSelectedMaterial, "§e" + type.name)
                    .setCustomModelData(selected ? 0 : CMDs.Simulator.NEW_PHASE)
                    .setLore(Collections.singletonList("§eClick to select"))
                    .setCallback(click -> {
                        SimulatorCursor.setCursorType(player, type);
                        player.closeInventory();
                    });
            inventory.setItem(slot, swItem);
            slot += 2;
        }
    }
}
